submodule update: add --remote for submodule's upstream changes
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
06b1abb5 11 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
adc54235 12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 13 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 14 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 15OPTIONS_SPEC=
70c7ac22 16. git-sh-setup
d0ad8251 17. git-sh-i18n
98fcf840 18. git-parse-remote
70c7ac22
LH
19require_work_tree
20
5c08dbbd 21command=
ecda0723 22branch=
d27b876b 23force=
d92a3959 24reference=
70c7ac22 25cached=
48bb3033
GP
26recursive=
27init=
1c244f6e 28files=
06b1abb5 29remote=
31ca3ac3 30nofetch=
32948425 31update=
15fc56a8 32prefix=
73b0898d 33custom_name=
70c7ac22 34
967b2c66
JS
35# The function takes at most 2 arguments. The first argument is the
36# URL that navigates to the submodule origin repo. When relative, this URL
37# is relative to the superproject origin URL repo. The second up_path
38# argument, if specified, is the relative path that navigates
39# from the submodule working tree to the superproject working tree.
40#
41# The output of the function is the origin URL of the submodule.
42#
43# The output will either be an absolute URL or filesystem path (if the
44# superproject origin URL is an absolute URL or filesystem path,
45# respectively) or a relative file system path (if the superproject
46# origin URL is a relative file system path).
47#
48# When the output is a relative file system path, the path is either
49# relative to the submodule working tree, if up_path is specified, or to
50# the superproject working tree otherwise.
f31a522a
ML
51resolve_relative_url ()
52{
98fcf840 53 remote=$(get_default_remote)
8e7e6f39 54 remoteurl=$(git config "remote.$remote.url") ||
4d689320 55 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 56 url="$1"
99b120af 57 remoteurl=${remoteurl%/}
ea640cc6 58 sep=/
967b2c66
JS
59 up_path="$2"
60
61 case "$remoteurl" in
62 *:*|/*)
63 is_relative=
64 ;;
758615e2
JS
65 ./*|../*)
66 is_relative=t
67 ;;
967b2c66
JS
68 *)
69 is_relative=t
758615e2 70 remoteurl="./$remoteurl"
967b2c66
JS
71 ;;
72 esac
73
f31a522a
ML
74 while test -n "$url"
75 do
76 case "$url" in
77 ../*)
78 url="${url#../}"
ea640cc6
TR
79 case "$remoteurl" in
80 */*)
81 remoteurl="${remoteurl%/*}"
82 ;;
83 *:*)
84 remoteurl="${remoteurl%:*}"
85 sep=:
86 ;;
87 *)
758615e2
JS
88 if test -z "$is_relative" || test "." = "$remoteurl"
89 then
90 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
91 else
92 remoteurl=.
93 fi
ea640cc6
TR
94 ;;
95 esac
f31a522a
ML
96 ;;
97 ./*)
98 url="${url#./}"
99 ;;
100 *)
101 break;;
102 esac
103 done
758615e2
JS
104 remoteurl="$remoteurl$sep${url%/}"
105 echo "${is_relative:+${up_path}}${remoteurl#./}"
f31a522a
ML
106}
107
a7b3269c
DA
108#
109# Get submodule info for registered submodules
110# $@ = path to limit submodule list
111#
112module_list()
113{
be9d0a3a
HV
114 (
115 git ls-files --error-unmatch --stage -- "$@" ||
116 echo "unmatched pathspec exists"
117 ) |
313ee0d6
NMC
118 perl -e '
119 my %unmerged = ();
120 my ($null_sha1) = ("0" x 40);
be9d0a3a
HV
121 my @out = ();
122 my $unmatched = 0;
313ee0d6 123 while (<STDIN>) {
be9d0a3a
HV
124 if (/^unmatched pathspec/) {
125 $unmatched = 1;
126 next;
127 }
313ee0d6
NMC
128 chomp;
129 my ($mode, $sha1, $stage, $path) =
130 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
131 next unless $mode eq "160000";
132 if ($stage ne "0") {
133 if (!$unmerged{$path}++) {
be9d0a3a 134 push @out, "$mode $null_sha1 U\t$path\n";
313ee0d6
NMC
135 }
136 next;
137 }
be9d0a3a
HV
138 push @out, "$_\n";
139 }
140 if ($unmatched) {
141 print "#unmatched\n";
142 } else {
143 print for (@out);
313ee0d6
NMC
144 }
145 '
a7b3269c
DA
146}
147
be9d0a3a
HV
148die_if_unmatched ()
149{
150 if test "$1" = "#unmatched"
151 then
152 exit 1
153 fi
154}
155
88ce00c3
TK
156#
157# Print a submodule configuration setting
158#
159# $1 = submodule name
160# $2 = option name
161# $3 = default value
162#
163# Checks in the usual git-config places first (for overrides),
164# otherwise it falls back on .gitmodules. This allows you to
165# distribute project-wide defaults in .gitmodules, while still
166# customizing individual repositories if necessary. If the option is
167# not in .gitmodules either, print a default value.
168#
169get_submodule_config () {
170 name="$1"
171 option="$2"
172 default="$3"
173 value=$(git config submodule."$name"."$option")
174 if test -z "$value"
175 then
176 value=$(git config -f .gitmodules submodule."$name"."$option")
177 fi
178 printf '%s' "${value:-$default}"
179}
180
181
941987a5
LH
182#
183# Map submodule path to submodule name
184#
185# $1 = path
186#
187module_name()
188{
537601ac 189 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
64394e3a 190 sm_path="$1"
fe22e542 191 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 192 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 193 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
1e42258a 194 test -z "$name" &&
64394e3a 195 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
1e42258a 196 echo "$name"
941987a5 197}
33aa6fff
LH
198
199#
200# Clone a submodule
201#
23a485e3 202# Prior to calling, cmd_update checks that a possibly existing
ecda0723 203# path is not a git repository.
23a485e3 204# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
205# since it is the location of a new submodule.
206#
33aa6fff
LH
207module_clone()
208{
64394e3a 209 sm_path=$1
73b0898d
JL
210 name=$2
211 url=$3
212 reference="$4"
7e60407f
JL
213 quiet=
214 if test -n "$GIT_QUIET"
215 then
216 quiet=-q
217 fi
33aa6fff 218
501770e1
FG
219 gitdir=
220 gitdir_base=
69c30517 221 base_name=$(dirname "$name")
33aa6fff 222
501770e1 223 gitdir=$(git rev-parse --git-dir)
69c30517
JL
224 gitdir_base="$gitdir/modules/$base_name"
225 gitdir="$gitdir/modules/$name"
501770e1
FG
226
227 if test -d "$gitdir"
d92a3959 228 then
64394e3a 229 mkdir -p "$sm_path"
501770e1 230 rm -f "$gitdir/index"
d92a3959 231 else
501770e1 232 mkdir -p "$gitdir_base"
be8779f7
DG
233 (
234 clear_local_git_env
235 git clone $quiet -n ${reference:+"$reference"} \
236 --separate-git-dir "$gitdir" "$url" "$sm_path"
237 ) ||
64394e3a 238 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
501770e1 239 fi
ea115a0d 240
6eafa6d0
JL
241 # We already are at the root of the work tree but cd_to_toplevel will
242 # resolve any symlinks that might be present in $PWD
243 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
15b3c82c 244 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
4dce7d9b
JS
245 # normalize Windows-style absolute paths to POSIX-style absolute paths
246 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
247 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
d75219b4
JL
248 # Remove all common leading directories after a sanity check
249 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
250 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
251 fi
252 while test "${a%%/*}" = "${b%%/*}"
253 do
254 a=${a#*/}
255 b=${b#*/}
256 done
257 # Now chop off the trailing '/'s that were added in the beginning
258 a=${a%/}
259 b=${b%/}
260
c5bc42b9
BW
261 # Turn each leading "*/" component into "../"
262 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
64394e3a 263 echo "gitdir: $rel/$a" >"$sm_path/.git"
69c30517 264
c5bc42b9 265 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
64394e3a 266 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
33aa6fff
LH
267}
268
ecda0723
SV
269#
270# Add a new submodule to the working tree, .gitmodules and the index
271#
ec05df35 272# $@ = repo path
ecda0723
SV
273#
274# optional branch is stored in global branch variable
275#
23a485e3 276cmd_add()
ecda0723 277{
5c08dbbd
JH
278 # parse $args after "submodule ... add".
279 while test $# -ne 0
280 do
281 case "$1" in
282 -b | --branch)
283 case "$2" in '') usage ;; esac
284 branch=$2
285 shift
286 ;;
d27b876b
JL
287 -f | --force)
288 force=$1
289 ;;
5c08dbbd 290 -q|--quiet)
2e6a30ef 291 GIT_QUIET=1
5c08dbbd 292 ;;
d92a3959
MT
293 --reference)
294 case "$2" in '') usage ;; esac
295 reference="--reference=$2"
296 shift
297 ;;
298 --reference=*)
299 reference="$1"
d92a3959 300 ;;
73b0898d
JL
301 --name)
302 case "$2" in '') usage ;; esac
303 custom_name=$2
304 shift
305 ;;
5c08dbbd
JH
306 --)
307 shift
308 break
309 ;;
310 -*)
311 usage
312 ;;
313 *)
314 break
315 ;;
316 esac
317 shift
318 done
319
ecda0723 320 repo=$1
64394e3a 321 sm_path=$2
ecda0723 322
64394e3a
RJ
323 if test -z "$sm_path"; then
324 sm_path=$(echo "$repo" |
1414e578
JL
325 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
326 fi
327
64394e3a 328 if test -z "$repo" -o -z "$sm_path"; then
ecda0723
SV
329 usage
330 fi
331
ec05df35
ML
332 # assure repo is absolute or relative to parent
333 case "$repo" in
334 ./*|../*)
335 # dereference source url relative to parent's url
336 realrepo=$(resolve_relative_url "$repo") || exit
337 ;;
338 *:*|/*)
339 # absolute url
340 realrepo=$repo
341 ;;
342 *)
497ee872 343 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
344 ;;
345 esac
346
db75ada5
MG
347 # normalize path:
348 # multiple //; leading ./; /./; /../; trailing /
64394e3a 349 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
350 sed -e '
351 s|//*|/|g
352 s|^\(\./\)*||
353 s|/\./|/|g
354 :start
355 s|\([^/]*\)/\.\./||
356 tstart
357 s|/*$||
358 ')
64394e3a
RJ
359 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
360 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 361
64394e3a 362 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 363 then
6ff875c5 364 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 365\$sm_path
6ff875c5 366Use -f if you really want to add it." >&2
d27b876b
JL
367 exit 1
368 fi
369
73b0898d
JL
370 if test -n "$custom_name"
371 then
372 sm_name="$custom_name"
373 else
374 sm_name="$sm_path"
375 fi
376
d4264ca3 377 # perhaps the path exists and is already a git repo, else clone it
64394e3a 378 if test -e "$sm_path"
d4264ca3 379 then
64394e3a 380 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
d4264ca3 381 then
64394e3a 382 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 383 else
64394e3a 384 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 385 fi
c2f93917 386
d4264ca3 387 else
4b7c286e
JL
388 if test -d ".git/modules/$sm_name"
389 then
390 if test -z "$force"
391 then
392 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
393 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
394 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
395 echo >&2 " $realrepo"
396 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
397 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
398 else
399 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
400 fi
401 fi
73b0898d 402 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" || exit
ea10b60c 403 (
74ae1419 404 clear_local_git_env
64394e3a 405 cd "$sm_path" &&
ea10b60c
BJ
406 # ash fails to wordsplit ${branch:+-b "$branch"...}
407 case "$branch" in
408 '') git checkout -f -q ;;
502dc5b6 409 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
ea10b60c 410 esac
64394e3a 411 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 412 fi
73b0898d 413 git config submodule."$sm_name".url "$realrepo"
d4264ca3 414
64394e3a
RJ
415 git add $force "$sm_path" ||
416 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 417
73b0898d
JL
418 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
419 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
31991b02 420 git add --force .gitmodules ||
64394e3a 421 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
422}
423
19a31f9c
ML
424#
425# Execute an arbitrary command sequence in each checked out
426# submodule
427#
428# $@ = command to execute
429#
430cmd_foreach()
431{
1d5bec8b
JH
432 # parse $args after "submodule ... foreach".
433 while test $# -ne 0
434 do
435 case "$1" in
436 -q|--quiet)
437 GIT_QUIET=1
438 ;;
15fc56a8
JH
439 --recursive)
440 recursive=1
441 ;;
1d5bec8b
JH
442 -*)
443 usage
444 ;;
445 *)
446 break
447 ;;
448 esac
449 shift
450 done
451
f030c96d
ÆAB
452 toplevel=$(pwd)
453
4dca1aa6
BC
454 # dup stdin so that it can be restored when running the external
455 # command in the subshell (and a recursive call to this function)
456 exec 3<&0
457
a7b3269c 458 module_list |
64394e3a 459 while read mode sha1 stage sm_path
19a31f9c 460 do
be9d0a3a 461 die_if_unmatched "$mode"
64394e3a 462 if test -e "$sm_path"/.git
19a31f9c 463 then
64394e3a
RJ
464 say "$(eval_gettext "Entering '\$prefix\$sm_path'")"
465 name=$(module_name "$sm_path")
15fc56a8 466 (
64394e3a 467 prefix="$prefix$sm_path/"
74ae1419 468 clear_local_git_env
64394e3a
RJ
469 # we make $path available to scripts ...
470 path=$sm_path
471 cd "$sm_path" &&
15fc56a8
JH
472 eval "$@" &&
473 if test -n "$recursive"
474 then
475 cmd_foreach "--recursive" "$@"
476 fi
4dca1aa6 477 ) <&3 3<&- ||
64394e3a 478 die "$(eval_gettext "Stopping at '\$sm_path'; script returned non-zero status.")"
19a31f9c
ML
479 fi
480 done
481}
482
70c7ac22 483#
211b7f19 484# Register submodules in .git/config
70c7ac22
LH
485#
486# $@ = requested paths (default to all)
487#
23a485e3 488cmd_init()
70c7ac22 489{
5c08dbbd
JH
490 # parse $args after "submodule ... init".
491 while test $# -ne 0
492 do
493 case "$1" in
494 -q|--quiet)
2e6a30ef 495 GIT_QUIET=1
5c08dbbd
JH
496 ;;
497 --)
498 shift
499 break
500 ;;
501 -*)
502 usage
503 ;;
504 *)
505 break
506 ;;
507 esac
508 shift
509 done
510
a7b3269c 511 module_list "$@" |
64394e3a 512 while read mode sha1 stage sm_path
70c7ac22 513 do
be9d0a3a 514 die_if_unmatched "$mode"
64394e3a 515 name=$(module_name "$sm_path") || exit
c1c259e2
JL
516
517 # Copy url setting when it is not set yet
2cd9de3e
JL
518 if test -z "$(git config "submodule.$name.url")"
519 then
520 url=$(git config -f .gitmodules submodule."$name".url)
521 test -z "$url" &&
64394e3a 522 die "$(eval_gettext "No url found for submodule path '\$sm_path' in .gitmodules")"
2cd9de3e
JL
523
524 # Possibly a url relative to parent
525 case "$url" in
526 ./*|../*)
527 url=$(resolve_relative_url "$url") || exit
528 ;;
529 esac
530 git config submodule."$name".url "$url" ||
64394e3a 531 die "$(eval_gettext "Failed to register url for submodule path '\$sm_path'")"
c1c259e2
JL
532
533 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$sm_path'")"
2cd9de3e 534 fi
70c7ac22 535
2cd9de3e 536 # Copy "update" setting when it is not set yet
32948425
JH
537 upd="$(git config -f .gitmodules submodule."$name".update)"
538 test -z "$upd" ||
2cd9de3e 539 test -n "$(git config submodule."$name".update)" ||
32948425 540 git config submodule."$name".update "$upd" ||
64394e3a 541 die "$(eval_gettext "Failed to register update mode for submodule path '\$sm_path'")"
70c7ac22
LH
542 done
543}
544
545#
211b7f19 546# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
547#
548# $@ = requested paths (default to all)
549#
23a485e3 550cmd_update()
70c7ac22 551{
5c08dbbd 552 # parse $args after "submodule ... update".
98dbe63d 553 orig_flags=
5c08dbbd
JH
554 while test $# -ne 0
555 do
556 case "$1" in
557 -q|--quiet)
2e6a30ef 558 GIT_QUIET=1
5c08dbbd 559 ;;
be4d2c83 560 -i|--init)
d92a3959 561 init=1
be4d2c83 562 ;;
06b1abb5
TK
563 --remote)
564 remote=1
565 ;;
31ca3ac3 566 -N|--no-fetch)
31ca3ac3
FF
567 nofetch=1
568 ;;
9db31bdf
NMC
569 -f|--force)
570 force=$1
571 ;;
ca2cedba 572 -r|--rebase)
32948425 573 update="rebase"
ca2cedba 574 ;;
d92a3959
MT
575 --reference)
576 case "$2" in '') usage ;; esac
577 reference="--reference=$2"
98dbe63d
KB
578 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
579 shift
d92a3959
MT
580 ;;
581 --reference=*)
582 reference="$1"
d92a3959 583 ;;
42b49178 584 -m|--merge)
42b49178
JH
585 update="merge"
586 ;;
b13fd5c1 587 --recursive)
b13fd5c1
JH
588 recursive=1
589 ;;
efc5fb6a
JH
590 --checkout)
591 update="checkout"
592 ;;
5c08dbbd
JH
593 --)
594 shift
595 break
596 ;;
597 -*)
598 usage
599 ;;
600 *)
601 break
602 ;;
603 esac
98dbe63d
KB
604 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
605 shift
5c08dbbd
JH
606 done
607
d92a3959
MT
608 if test -n "$init"
609 then
610 cmd_init "--" "$@" || return
611 fi
612
1b4735d9 613 cloned_modules=
15ffb7cd
FG
614 module_list "$@" | {
615 err=
64394e3a 616 while read mode sha1 stage sm_path
70c7ac22 617 do
be9d0a3a 618 die_if_unmatched "$mode"
313ee0d6
NMC
619 if test "$stage" = U
620 then
64394e3a 621 echo >&2 "Skipping unmerged submodule $sm_path"
313ee0d6
NMC
622 continue
623 fi
64394e3a 624 name=$(module_name "$sm_path") || exit
5be60078 625 url=$(git config submodule."$name".url)
06b1abb5 626 branch=$(get_submodule_config "$name" branch master)
efc5fb6a
JH
627 if ! test -z "$update"
628 then
629 update_module=$update
630 else
631 update_module=$(git config submodule."$name".update)
632 fi
633
634 if test "$update_module" = "none"
635 then
64394e3a 636 echo "Skipping submodule '$sm_path'"
efc5fb6a
JH
637 continue
638 fi
639
211b7f19 640 if test -z "$url"
70c7ac22
LH
641 then
642 # Only mention uninitialized submodules when its
643 # path have been specified
644 test "$#" != "0" &&
64394e3a 645 say "$(eval_gettext "Submodule path '\$sm_path' not initialized
1c2ef66f 646Maybe you want to use 'update --init'?")"
211b7f19
LH
647 continue
648 fi
649
64394e3a 650 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
211b7f19 651 then
73b0898d 652 module_clone "$sm_path" "$name" "$url" "$reference" || exit
1b4735d9 653 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
654 subsha1=
655 else
64394e3a 656 subsha1=$(clear_local_git_env; cd "$sm_path" &&
5be60078 657 git rev-parse --verify HEAD) ||
64394e3a 658 die "$(eval_gettext "Unable to find current revision in submodule path '\$sm_path'")"
70c7ac22 659 fi
211b7f19 660
06b1abb5
TK
661 if test -n "$remote"
662 then
663 if test -z "$nofetch"
664 then
665 # Fetch remote before determining tracking $sha1
666 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
667 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
668 fi
669 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
670 sha1=$(clear_local_git_env; cd "$sm_path" &&
671 git rev-parse --verify "${remote_name}/${branch}") ||
672 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
673 fi
674
01d47215 675 if test "$subsha1" != "$sha1" -o -n "$force"
70c7ac22 676 then
9db31bdf
NMC
677 subforce=$force
678 # If we don't already have a -f flag and the submodule has never been checked out
679 if test -z "$subsha1" -a -z "$force"
b9b378a0 680 then
9db31bdf 681 subforce="-f"
b9b378a0 682 fi
31ca3ac3
FF
683
684 if test -z "$nofetch"
685 then
e5f522d6
JL
686 # Run fetch only if $sha1 isn't present or it
687 # is not reachable from a ref.
64394e3a 688 (clear_local_git_env; cd "$sm_path" &&
f5799e05 689 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 690 test -z "$rev") || git-fetch)) ||
64394e3a 691 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
31ca3ac3
FF
692 fi
693
1b4735d9
SO
694 # Is this something we just cloned?
695 case ";$cloned_modules;" in
696 *";$name;"*)
697 # then there is no local change to integrate
698 update_module= ;;
699 esac
700
877449c1 701 must_die_on_failure=
32948425
JH
702 case "$update_module" in
703 rebase)
704 command="git rebase"
64394e3a
RJ
705 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$sm_path'")"
706 say_msg="$(eval_gettext "Submodule path '\$sm_path': rebased into '\$sha1'")"
877449c1 707 must_die_on_failure=yes
32948425 708 ;;
42b49178
JH
709 merge)
710 command="git merge"
64394e3a
RJ
711 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$sm_path'")"
712 say_msg="$(eval_gettext "Submodule path '\$sm_path': merged in '\$sha1'")"
877449c1 713 must_die_on_failure=yes
42b49178 714 ;;
32948425 715 *)
9db31bdf 716 command="git checkout $subforce -q"
64394e3a
RJ
717 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$sm_path'")"
718 say_msg="$(eval_gettext "Submodule path '\$sm_path': checked out '\$sha1'")"
32948425
JH
719 ;;
720 esac
70c7ac22 721
64394e3a 722 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 723 then
ff968f03 724 say "$say_msg"
877449c1
JH
725 elif test -n "$must_die_on_failure"
726 then
ff968f03 727 die_with_status 2 "$die_msg"
15ffb7cd 728 else
ff968f03 729 err="${err};$die_msg"
877449c1 730 continue
15ffb7cd 731 fi
70c7ac22 732 fi
b13fd5c1
JH
733
734 if test -n "$recursive"
735 then
64394e3a 736 (clear_local_git_env; cd "$sm_path" && eval cmd_update "$orig_flags")
15ffb7cd
FG
737 res=$?
738 if test $res -gt 0
739 then
64394e3a 740 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
15ffb7cd
FG
741 if test $res -eq 1
742 then
ff968f03 743 err="${err};$die_msg"
15ffb7cd
FG
744 continue
745 else
ff968f03 746 die_with_status $res "$die_msg"
15ffb7cd
FG
747 fi
748 fi
b13fd5c1 749 fi
70c7ac22 750 done
15ffb7cd
FG
751
752 if test -n "$err"
753 then
754 OIFS=$IFS
755 IFS=';'
756 for e in $err
757 do
758 if test -n "$e"
759 then
760 echo >&2 "$e"
761 fi
762 done
763 IFS=$OIFS
764 exit 1
765 fi
766 }
70c7ac22
LH
767}
768
bffe71f4
EM
769set_name_rev () {
770 revname=$( (
74ae1419 771 clear_local_git_env
bffe71f4 772 cd "$1" && {
5be60078
JH
773 git describe "$2" 2>/dev/null ||
774 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
775 git describe --contains "$2" 2>/dev/null ||
776 git describe --all --always "$2"
bffe71f4
EM
777 }
778 ) )
779 test -z "$revname" || revname=" ($revname)"
780}
28f9af5d
PY
781#
782# Show commit summary for submodules in index or working tree
783#
784# If '--cached' is given, show summary between index and given commit,
785# or between working tree and given commit
786#
787# $@ = [commit (default 'HEAD'),] requested paths (default all)
788#
789cmd_summary() {
f2dc06a3 790 summary_limit=-1
d0f64dd4 791 for_status=
1c244f6e 792 diff_cmd=diff-index
f2dc06a3 793
28f9af5d
PY
794 # parse $args after "submodule ... summary".
795 while test $# -ne 0
796 do
797 case "$1" in
798 --cached)
799 cached="$1"
800 ;;
1c244f6e
JL
801 --files)
802 files="$1"
803 ;;
d0f64dd4
PY
804 --for-status)
805 for_status="$1"
806 ;;
f2dc06a3
PY
807 -n|--summary-limit)
808 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
809 then
810 :
811 else
812 usage
813 fi
814 shift
815 ;;
28f9af5d
PY
816 --)
817 shift
818 break
819 ;;
820 -*)
821 usage
822 ;;
823 *)
824 break
825 ;;
826 esac
827 shift
828 done
bffe71f4 829
f2dc06a3
PY
830 test $summary_limit = 0 && return
831
3deea89c 832 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
833 then
834 head=$rev
caa9c3ca 835 test $# = 0 || shift
3deea89c
JH
836 elif test -z "$1" -o "$1" = "HEAD"
837 then
14e940d7
JH
838 # before the first commit: compare with an empty tree
839 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 840 test -z "$1" || shift
28f9af5d 841 else
3deea89c 842 head="HEAD"
28f9af5d
PY
843 fi
844
1c244f6e
JL
845 if [ -n "$files" ]
846 then
847 test -n "$cached" &&
465d6a00 848 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
849 diff_cmd=diff-files
850 head=
851 fi
852
28f9af5d
PY
853 cd_to_toplevel
854 # Get modified modules cared by user
18076502 855 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 856 sane_egrep '^:([0-7]* )?160000' |
28f9af5d
PY
857 while read mod_src mod_dst sha1_src sha1_dst status name
858 do
859 # Always show modules deleted or type-changed (blob<->module)
860 test $status = D -o $status = T && echo "$name" && continue
861 # Also show added or modified modules which are checked out
862 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
863 echo "$name"
864 done
865 )
1cb639e6 866
d0f64dd4
PY
867 test -z "$modules" && return
868
18076502 869 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 870 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
871 cut -c2- |
872 while read mod_src mod_dst sha1_src sha1_dst status name
873 do
874 if test -z "$cached" &&
875 test $sha1_dst = 0000000000000000000000000000000000000000
876 then
877 case "$mod_dst" in
878 160000)
879 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
880 ;;
881 100644 | 100755 | 120000)
882 sha1_dst=$(git hash-object $name)
883 ;;
884 000000)
885 ;; # removed
886 *)
887 # unexpected type
6ff875c5 888 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
889 continue ;;
890 esac
891 fi
892 missing_src=
893 missing_dst=
894
895 test $mod_src = 160000 &&
30353a40 896 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
897 missing_src=t
898
899 test $mod_dst = 160000 &&
30353a40 900 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 901 missing_dst=t
bffe71f4 902
1cb639e6
PY
903 total_commits=
904 case "$missing_src,$missing_dst" in
905 t,)
f62f8212 906 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
1cb639e6
PY
907 ;;
908 ,t)
f62f8212 909 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
910 ;;
911 t,t)
f62f8212 912 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
913 ;;
914 *)
915 errmsg=
916 total_commits=$(
917 if test $mod_src = 160000 -a $mod_dst = 160000
918 then
919 range="$sha1_src...$sha1_dst"
920 elif test $mod_src = 160000
921 then
922 range=$sha1_src
923 else
924 range=$sha1_dst
925 fi
926 GIT_DIR="$name/.git" \
b0e621ad 927 git rev-list --first-parent $range -- | wc -l
1cb639e6 928 )
eed35595 929 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
930 ;;
931 esac
932
933 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
934 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
935 if test $status = T
936 then
b3e73449
ÆAB
937 blob="$(gettext "blob")"
938 submodule="$(gettext "submodule")"
1cb639e6
PY
939 if test $mod_dst = 160000
940 then
b3e73449 941 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 942 else
b3e73449 943 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
944 fi
945 else
946 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
947 fi
948 if test -n "$errmsg"
949 then
950 # Don't give error msg for modification whose dst is not submodule
951 # i.e. deleted or changed to blob
952 test $mod_dst = 160000 && echo "$errmsg"
953 else
954 if test $mod_src = 160000 -a $mod_dst = 160000
955 then
f2dc06a3
PY
956 limit=
957 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 958 GIT_DIR="$name/.git" \
f2dc06a3 959 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
960 --first-parent $sha1_src...$sha1_dst
961 elif test $mod_dst = 160000
962 then
963 GIT_DIR="$name/.git" \
964 git log --pretty='format: > %s' -1 $sha1_dst
965 else
966 GIT_DIR="$name/.git" \
967 git log --pretty='format: < %s' -1 $sha1_src
968 fi
969 echo
970 fi
971 echo
d0f64dd4
PY
972 done |
973 if test -n "$for_status"; then
f17a5d34 974 if [ -n "$files" ]; then
6ff875c5 975 gettextln "# Submodules changed but not updated:"
f17a5d34 976 else
6ff875c5 977 gettextln "# Submodule changes to be committed:"
f17a5d34 978 fi
d0f64dd4
PY
979 echo "#"
980 sed -e 's|^|# |' -e 's|^# $|#|'
981 else
982 cat
983 fi
28f9af5d 984}
70c7ac22 985#
941987a5 986# List all submodules, prefixed with:
70c7ac22
LH
987# - submodule not initialized
988# + different revision checked out
989#
990# If --cached was specified the revision in the index will be printed
991# instead of the currently checked out revision.
992#
993# $@ = requested paths (default to all)
994#
23a485e3 995cmd_status()
70c7ac22 996{
5c08dbbd
JH
997 # parse $args after "submodule ... status".
998 while test $# -ne 0
999 do
1000 case "$1" in
1001 -q|--quiet)
2e6a30ef 1002 GIT_QUIET=1
5c08dbbd
JH
1003 ;;
1004 --cached)
1005 cached=1
1006 ;;
64b19ffe
JH
1007 --recursive)
1008 recursive=1
1009 ;;
5c08dbbd
JH
1010 --)
1011 shift
1012 break
1013 ;;
1014 -*)
1015 usage
1016 ;;
1017 *)
1018 break
1019 ;;
1020 esac
1021 shift
1022 done
1023
a7b3269c 1024 module_list "$@" |
64394e3a 1025 while read mode sha1 stage sm_path
70c7ac22 1026 do
be9d0a3a 1027 die_if_unmatched "$mode"
64394e3a 1028 name=$(module_name "$sm_path") || exit
5be60078 1029 url=$(git config submodule."$name".url)
64394e3a 1030 displaypath="$prefix$sm_path"
313ee0d6
NMC
1031 if test "$stage" = U
1032 then
1033 say "U$sha1 $displaypath"
1034 continue
1035 fi
64394e3a 1036 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
70c7ac22 1037 then
64b19ffe 1038 say "-$sha1 $displaypath"
70c7ac22
LH
1039 continue;
1040 fi
64394e3a
RJ
1041 set_name_rev "$sm_path" "$sha1"
1042 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1043 then
64b19ffe 1044 say " $sha1 $displaypath$revname"
70c7ac22
LH
1045 else
1046 if test -z "$cached"
1047 then
64394e3a
RJ
1048 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1049 set_name_rev "$sm_path" "$sha1"
70c7ac22 1050 fi
64b19ffe
JH
1051 say "+$sha1 $displaypath$revname"
1052 fi
1053
1054 if test -n "$recursive"
1055 then
1056 (
1057 prefix="$displaypath/"
74ae1419 1058 clear_local_git_env
64394e3a 1059 cd "$sm_path" &&
e15bec0e 1060 eval cmd_status
64b19ffe 1061 ) ||
64394e3a 1062 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1063 fi
1064 done
1065}
2327f61e
DA
1066#
1067# Sync remote urls for submodules
1068# This makes the value for remote.$remote.url match the value
1069# specified in .gitmodules.
1070#
1071cmd_sync()
1072{
1073 while test $# -ne 0
1074 do
1075 case "$1" in
1076 -q|--quiet)
2e6a30ef 1077 GIT_QUIET=1
2327f61e
DA
1078 shift
1079 ;;
82f49f29
PH
1080 --recursive)
1081 recursive=1
1082 shift
1083 ;;
2327f61e
DA
1084 --)
1085 shift
1086 break
1087 ;;
1088 -*)
1089 usage
1090 ;;
1091 *)
1092 break
1093 ;;
1094 esac
1095 done
1096 cd_to_toplevel
1097 module_list "$@" |
64394e3a 1098 while read mode sha1 stage sm_path
2327f61e 1099 do
be9d0a3a 1100 die_if_unmatched "$mode"
64394e3a 1101 name=$(module_name "$sm_path")
2327f61e 1102 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1103
1104 # Possibly a url relative to parent
1105 case "$url" in
1106 ./*|../*)
967b2c66
JS
1107 # rewrite foo/bar as ../.. to find path from
1108 # submodule work tree to superproject work tree
1109 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1110 # guarantee a trailing /
1111 up_path=${up_path%/}/ &&
1112 # path from submodule work tree to submodule origin repo
1113 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1114 # path from superproject work tree to submodule origin repo
1115 super_config_url=$(resolve_relative_url "$url") || exit
1116 ;;
1117 *)
1118 sub_origin_url="$url"
1119 super_config_url="$url"
baede9f8
JH
1120 ;;
1121 esac
1122
ccee6086 1123 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1124 then
82f49f29 1125 say "$(eval_gettext "Synchronizing submodule url for '\$prefix\$sm_path'")"
967b2c66 1126 git config submodule."$name".url "$super_config_url"
ccee6086 1127
64394e3a 1128 if test -e "$sm_path"/.git
ccee6086
JH
1129 then
1130 (
1131 clear_local_git_env
64394e3a 1132 cd "$sm_path"
ccee6086 1133 remote=$(get_default_remote)
967b2c66 1134 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1135
1136 if test -n "$recursive"
1137 then
1138 prefix="$prefix$sm_path/"
1139 eval cmd_sync
1140 fi
ccee6086
JH
1141 )
1142 fi
2327f61e
DA
1143 fi
1144 done
1145}
70c7ac22 1146
5c08dbbd
JH
1147# This loop parses the command line arguments to find the
1148# subcommand name to dispatch. Parsing of the subcommand specific
1149# options are primarily done by the subcommand implementations.
1150# Subcommand specific options such as --branch and --cached are
1151# parsed here as well, for backward compatibility.
1152
1153while test $# != 0 && test -z "$command"
70c7ac22
LH
1154do
1155 case "$1" in
2327f61e 1156 add | foreach | init | update | status | summary | sync)
5c08dbbd 1157 command=$1
70c7ac22
LH
1158 ;;
1159 -q|--quiet)
2e6a30ef 1160 GIT_QUIET=1
70c7ac22 1161 ;;
ecda0723
SV
1162 -b|--branch)
1163 case "$2" in
1164 '')
1165 usage
1166 ;;
1167 esac
1168 branch="$2"; shift
1169 ;;
70c7ac22 1170 --cached)
28f9af5d 1171 cached="$1"
70c7ac22
LH
1172 ;;
1173 --)
1174 break
1175 ;;
1176 -*)
1177 usage
1178 ;;
1179 *)
1180 break
1181 ;;
1182 esac
1183 shift
1184done
1185
5c08dbbd 1186# No command word defaults to "status"
af9c9f97
RR
1187if test -z "$command"
1188then
1189 if test $# = 0
1190 then
1191 command=status
1192 else
1193 usage
1194 fi
1195fi
5c08dbbd
JH
1196
1197# "-b branch" is accepted only by "add"
1198if test -n "$branch" && test "$command" != add
1199then
ecda0723 1200 usage
5c08dbbd
JH
1201fi
1202
28f9af5d
PY
1203# "--cached" is accepted only by "status" and "summary"
1204if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 1205then
70c7ac22 1206 usage
5c08dbbd
JH
1207fi
1208
1209"cmd_$command" "$@"